<!DOCTYPE html>
<html>

<head>
  <title> Tạo đơn hàng - dành cho Admin </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron py-4">
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
      <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
      <div class="col-sm-4">
        <select id="select-size" class="form-control">
          <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
          <option value="S"> Nhỏ</option>
          <option value="M"> Vừa</option>
          <option value="L"> Lớn</option>
        </select>
      </div>
      <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Mã voucher</label>
      <div class="col-sm-4">
        <input id="input-voucher" type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
      </div>
      <label class="col-sm-2 col-form-label">Loại pizza</label>
      <div class="col-sm-4">
        <select id="select-pizza" class="form-control">
          <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
          <option value="Seafood"> Hải sản</option>
          <option value="Hawaii"> Ha wai </option>
          <option value="Bacon"> Thịt hun khói </option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
      <div class="col-sm-4">
        <input id="input-fullname" type="text" class="form-control" placeholder="Họ và tên">
      </div>
      <label for="" class="col-sm-2 col-form-label">Email</label>
      <div class="col-sm-4">
        <input id="input-email" type="email" class="form-control" placeholder="Email">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Số điện thoại</label>
      <div class="col-sm-4">
        <input id="input-phone-number" type="text" class="form-control" placeholder="Số điện thoại">
      </div>
      <label class="col-sm-2 col-form-label">Địa chỉ</label>
      <div class="col-sm-4">
        <input id="input-address" type="text" class="form-control" placeholder="Địa chỉ">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Lời nhắn</label>
      <div class="col-sm-10">
        <textarea id="textarea-message" class="form-control" placeholder="Lời nhắn"></textarea>
      </div>
    </div>
    <div class="form-group text-right">
      <button onclick="onBtnAddOrderClick()" class="btn btn-primary">Create Order</button>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;
    const gBASE_URL_ORDERS = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gBASE_URL_VOUCHER = "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }

    // Hàm nhấn nút thêm order 
    function onBtnAddOrderClick() {
      var vOrderObj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
      }
      //B1: Thu thập dữ liệu
      thuThapDuLieu(vOrderObj);
      //B2: Kiểm tra dữ liệu 
      var vDataHopLe = kiemTraDuLieu(vOrderObj);
      if (vDataHopLe) {
        console.log(vOrderObj);
        // B3: Gọi Api tạo order mới
        callApiCreateNewOrder(vOrderObj);

      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      // load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var bDrinkOptionElement = document.createElement("option");
        bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(bDrinkOptionElement);
      }
    }
    //B1: Hàm thu thập dữ liệu
    function thuThapDuLieu(paramOrderObj) {
      var vSelectComboSize = document.getElementById("select-size");
      var vSelectDrink = document.getElementById("select-drink");
      var vInputVoucherId = document.getElementById("input-voucher");
      var vSelectTypePizza = document.getElementById("select-pizza");
      var vInputFullName = document.getElementById("input-fullname");
      var vInputEmail = document.getElementById("input-email");
      var vInputPhoneNumber = document.getElementById("input-phone-number");
      var vInputAddress = document.getElementById("input-address");
      var vTextAreaMessage = document.getElementById("textarea-message");

      paramOrderObj.kichCo = vSelectComboSize.value;
      paramOrderObj.idLoaiNuocUong = vSelectDrink.value;
      paramOrderObj.idVoucher = vInputVoucherId.value.trim();
      paramOrderObj.loaiPizza = vSelectTypePizza.value;
      paramOrderObj.hoTen = vInputFullName.value.trim();
      paramOrderObj.email = vInputEmail.value.trim();
      paramOrderObj.soDienThoai = vInputPhoneNumber.value.trim();
      paramOrderObj.diaChi = vInputAddress.value.trim();
      paramOrderObj.loiNhan = vTextAreaMessage.value.trim();

      if (paramOrderObj.kichCo === "S") {
        paramOrderObj.duongKinh = 20;
        paramOrderObj.suon = 2;
        paramOrderObj.salad = 200;
        paramOrderObj.soLuongNuoc = 2;
        paramOrderObj.thanhTien = 150000;
      } else if (paramOrderObj.kichCo === "M") {
        paramOrderObj.duongKinh = 25;
        paramOrderObj.suon = 4;
        paramOrderObj.salad = 300;
        paramOrderObj.soLuongNuoc = 3;
        paramOrderObj.thanhTien = 200000;
      } else if (paramOrderObj.kichCo === "L") {
        paramOrderObj.duongKinh = 30;
        paramOrderObj.suon = 8;
        paramOrderObj.salad = 500;
        paramOrderObj.soLuongNuoc = 4;
        paramOrderObj.thanhTien = 250000;
      }
    }

    // Hàm kiểm tra dữ liệu 
    function kiemTraDuLieu(paramOrderObj) {


      if (paramOrderObj.kichCo === "NOT_SELECT_COMBO") {
        alert("Vui lòng chọn kích cỡ pizza");
        return false;
      }

      if (paramOrderObj.idLoaiNuocUong === "NOT_SELECT_DRINK") {
        alert('Vui lòng chọn nước uống');
        return false;
      }
      if (paramOrderObj.loaiPizza === "NOT_SELECT_PIZZA") {
        alert('Vui lòng chọn loại Pizza');
        return false;
      }
      if (paramOrderObj.hoTen === "") {
        alert('Vui lòng nhập họ tên');
        return false;
      }
      if (paramOrderObj.email === "") {
        alert('Vui lòng nhập email');
        return false;
      }

      var vEmailRegex = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;

      if (!paramOrderObj.email.match(vEmailRegex)) {
        alert('Email không đúng định dạng');
        return false;
      }
      if (paramOrderObj.soDienThoai === "") {
        alert('Vui lòng nhập số điện thoại');
        return false;
      }
      if (paramOrderObj.soDienThoai.length !== 10) {
        alert('Số điện thoại không đúng định dạng (cần nhập 10 chữ số)');
        return false;
      }
      var vPhoneRegex = /(((\+|)84)|0)(3|5|7|8|9)+([0-9]{8})\b/;

      if (!paramOrderObj.soDienThoai.match(vPhoneRegex)) {
        alert('Số điện thoại không đúng định dạng');
        return false;
      }

      if (!isFinite(paramOrderObj.soDienThoai)) {
        alert('Số điện thoại phải là số');
        return false;
      }

      if (paramOrderObj.diaChi === "") {
        alert('Vui lòng nhập địa chỉ');
        return false;
      }
      if (paramOrderObj.idVoucher !== "") {
        var vXhttpVoucher = new XMLHttpRequest();
        // Gọi hàm Api kiểm tra mã voucher
        callApiCheckIdVoucher(vXhttpVoucher, paramOrderObj.idVoucher);
        var vStatusCode = vXhttpVoucher.status;
        if (vStatusCode !== gREQUEST_STATUS_OK) {
          alert("Không tìm thấy voucher " + paramOrderObj.idVoucher);
          return false;
        }
        console.log(vXhttpVoucher.responseText);
      }
      return true;
    }

    // Hàm gọi Api tạo order mới
    function callApiCreateNewOrder(paramOrderObj) {
      var vOrderString = JSON.stringify(paramOrderObj);
      var vXmlHttpCreateNewOrder = new XMLHttpRequest();
      vXmlHttpCreateNewOrder.open("POST", gBASE_URL_ORDERS, true);
      vXmlHttpCreateNewOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      vXmlHttpCreateNewOrder.send(vOrderString);
      vXmlHttpCreateNewOrder.onreadystatechange =
        function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) {
            var vCreatedOrder = vXmlHttpCreateNewOrder.responseText;
            console.log(vCreatedOrder);
            alert("Tạo đơn hàng thành công");
            const vUrlOpenToListViewSite = "indexListView.html";
            window.location.href = vUrlOpenToListViewSite;
          } else if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status !== gREQUEST_CREATE_SUCCESS) {
            alert("Tạo đơn hàng không thành công");
          }
        }
    }

    function callApiCheckIdVoucher(paramXhttp, paramIdVoucher) {
      paramXhttp.open("GET", gBASE_URL_VOUCHER + "/" + paramIdVoucher, false);
      paramXhttp.send(null);
    }

  </script>


</body>

</html>